#
# DO NOT MODIFY!!!!
# This file is automatically generated by Racc 1.4.16
# from Racc grammar file "".
#

require 'racc/parser.rb'

module Juli::LineAbsyn
  class Node
    def accept(visitor)
      visitor.visit_node(self)
    end
  end
  
  class StringNode < Node
    attr_accessor :str
  
    def initialize(str)
      @str = str
    end
  
    def accept(visitor)
      visitor.visit_string(self)
    end
  end

  class WikiName < StringNode
    def accept(visitor)
      visitor.visit_wikiname(self)
    end
  end

  class Url < StringNode
    def accept(visitor)
      visitor.visit_url(self)
    end
  end

  class Macro < Node
    attr_accessor :name, :rest

    def initialize(name, rest)
      @name = name
      @rest = rest
    end
  
    def accept(visitor)
      visitor.visit_macro(self)
    end
  end

  class ArrayNode < Node
    attr_accessor :array
  
    def initialize
      @array      = Array.new
    end
  
    def add(child)
      @array << child
      self
    end
  
    def accept(visitor)
      visitor.visit_array(self)
    end
  end

  # define Visitor default actions
  class Visitor
    def visit_node(n); end

    def visit_array(n)
      for n in n.array do
        n.accept(self)
      end
    end

    def visit_string(n); end
    def visit_wikiname(n); end
    def visit_url(n); end
    def visit_macro(n); end
  end

  # visitor for debug
  class DebugVisitor < Visitor
    attr_reader :array

    def initialize
      @array = []
    end

    def visit_string(n)
      @array << n.str
    end

    def visit_wikiname(n)
      @array << sprintf("W:%s", n.str)
    end

    def visit_url(n)
      @array << sprintf("U:%s", n.str)
    end

    def visit_macro(n)
      @array << sprintf("M:%s:%s", n.name, n.rest)
    end
  end
end

module Juli
  class LineParser < Racc::Parser

module_eval(<<'...end line_parser.y/module_eval...', 'line_parser.y', 125)
  # parse one line and return absyn tree for the line
  def parse(line, wikinames)
    @remain     = line
    @wikinames  = wikinames
    yyparse self, :scan
    @root
  end

private
  # Wikiname scanning algorithm is as follows:
  #
  # 1. input: [..............................................................]
  # 2. scan longest wikiname in wikiname-dictionary:
  #           [<---heading_remain---->LONGEST_WIKINAME<---trailing_remain--->]
  # 3. for remaining in head & trail, do 2. above recursively
  def scan(&block)
    scan_r(@remain, &block)
    yield [false, nil]
  end

  URL = '(https?|mailto|ftp):[\w\.\?&/@%^=~#-]+'

  # recursive scan
  def scan_r(str, &block)
    for w in @wikinames do
      case str
      # to escape wikiname string in <a>...</a>, it is prior to wikiname
      #
      # If word in <a ...>word</a> tag is a wikiname, it would be produced to
      # <a ...><a ...>word</a></a> because it is a wikiname.  In order to
      # avoid this, two ways can be considered:
      #
      # 1. introduce escape notation.  e.g. rdoc \word
      # 2. introduce special inline escape logic just for <a>...</a>
      #
      # I choose latter for simple usage.
      when /\A([^<]*)(<a[^>]*>[^<]*<\/a>)(.*)\z/m
        scan_r($1, &block)
        yield [:STRING, $2]   # <a>...</a> is just string even wikiname be there
        scan_r($3, &block)
        return

      # to escape wikiname string in HTML tag, it is prior to wikiname
      when /\A([^<]*)(<[^>]*>)(.*)\z/m
        scan_r($1, &block)
        yield [:STRING, $2]   # <a>...</a> is just string even wikiname be there
        scan_r($3, &block)
        return

      # escape of escape: \\{ -> \{
      when /\A([^\\]*)\\\\\{(.*)\z/m
        scan_r($1, &block)
        yield [:STRING, '\\{']
        scan_r($2, &block)
        return

      # explicit escape by \{!...}
      when /\A([^\\]*)\\\{!([^}]+)\}(.*)\z/m
        scan_r($1, &block)
        yield [:STRING, $2]
        scan_r($3, &block)
        return

      # macro \{command rest}
      when /\A([^\\]*)\\\{(\w+)\s*([^}]*)\}(.*)\z/m
        scan_r($1, &block)
        yield [:MACRO, [$2, $3]]
        scan_r($4, &block)
        return
      
      # URL is piror to wikiname
      when /\A(|.*[^\w])(#{URL})(.*)\z/m
        scan_r($1, &block)
        yield [:URL, $2]
        scan_r($4, &block)    # not $3 since URL itself has (...)
        return

      when /\A(.*)#{w}(.*)\z/m
        scan_r($1, &block)
        yield [:WIKINAME, w]
        scan_r($2, &block)
        return
      end
    end
    yield [:STRING, str]
  end

...end line_parser.y/module_eval...
##### State transition tables begin ###

racc_action_table = [
     5,     6,     7,     8,     9,     3,    10 ]

racc_action_check = [
     2,     2,     2,     2,     2,     1,     3 ]

racc_action_pointer = [
   nil,     5,    -2,     6,   nil,   nil,   nil,   nil,   nil,   nil,
   nil ]

racc_action_default = [
    -2,    -9,    -1,    -9,    -3,    -4,    -5,    -6,    -7,    -8,
    11 ]

racc_goto_table = [
     1,     2,     4 ]

racc_goto_check = [
     1,     2,     3 ]

racc_goto_pointer = [
   nil,     0,     1,     0 ]

racc_goto_default = [
   nil,   nil,   nil,   nil ]

racc_reduce_table = [
  0, 0, :racc_error,
  1, 8, :_reduce_1,
  0, 9, :_reduce_2,
  2, 9, :_reduce_3,
  1, 10, :_reduce_4,
  1, 10, :_reduce_5,
  1, 10, :_reduce_6,
  1, 10, :_reduce_7,
  1, 10, :_reduce_8 ]

racc_reduce_n = 9

racc_shift_n = 11

racc_token_table = {
  false => 0,
  :error => 1,
  :STRING => 2,
  :WIKINAME => 3,
  :TAG => 4,
  :URL => 5,
  :MACRO => 6 }

racc_nt_base = 7

racc_use_result_var = false

Racc_arg = [
  racc_action_table,
  racc_action_check,
  racc_action_default,
  racc_action_pointer,
  racc_goto_table,
  racc_goto_check,
  racc_goto_default,
  racc_goto_pointer,
  racc_nt_base,
  racc_reduce_table,
  racc_token_table,
  racc_shift_n,
  racc_reduce_n,
  racc_use_result_var ]

Racc_token_to_s_table = [
  "$end",
  "error",
  "STRING",
  "WIKINAME",
  "TAG",
  "URL",
  "MACRO",
  "$start",
  "line",
  "elements",
  "element" ]

Racc_debug_parser = false

##### State transition tables end #####

# reduce 0 omitted

module_eval(<<'.,.,', 'line_parser.y', 6)
  def _reduce_1(val, _values)
     @root = val[0]
  end
.,.,

module_eval(<<'.,.,', 'line_parser.y', 9)
  def _reduce_2(val, _values)
     LineAbsyn::ArrayNode.new
  end
.,.,

module_eval(<<'.,.,', 'line_parser.y', 10)
  def _reduce_3(val, _values)
     val[0].add(val[1])
  end
.,.,

module_eval(<<'.,.,', 'line_parser.y', 13)
  def _reduce_4(val, _values)
     LineAbsyn::StringNode.new(val[0])
  end
.,.,

module_eval(<<'.,.,', 'line_parser.y', 14)
  def _reduce_5(val, _values)
     LineAbsyn::WikiName.new(val[0])
  end
.,.,

module_eval(<<'.,.,', 'line_parser.y', 15)
  def _reduce_6(val, _values)
     LineAbsyn::StringNode.new(val[0])
  end
.,.,

module_eval(<<'.,.,', 'line_parser.y', 16)
  def _reduce_7(val, _values)
     LineAbsyn::Url.new(val[0])
  end
.,.,

module_eval(<<'.,.,', 'line_parser.y', 17)
  def _reduce_8(val, _values)
     LineAbsyn::Macro.new(val[0][0], val[0][1])
  end
.,.,

def _reduce_none(val, _values)
  val[0]
end

  end   # class LineParser
end   # module Juli


