#
# DO NOT MODIFY!!!!
# This file is automatically generated by Racc 1.4.16
# from Racc grammar file "".
#

require 'racc/parser.rb'

require 'juli/wiki'

module Juli
  class Parser < Racc::Parser

module_eval(<<'...end parser.y/module_eval...', 'parser.y', 76)
  require 'erb'
  require 'juli/visitor'

  # keep nest level; will be used to yield ')'
  #
  # This is used for both headline level and list nesting.
  class NestStack
    class InvalidOrder < StandardError; end

    def initialize
      @stack    = []
      @baseline = 0
    end

    # action on '('
    def push(length)
      if @stack.last && @stack.last >= length
        raise InvalidOrder, "top(#{@stack.last}) >= length(#{length})"
      end
      @stack << length
      @baseline = length
    end

    # current baseline
    def baseline
      @baseline
    end

    # action on ')'
    #
    # go up nest until length meets.  Block (mainly for ')') is called
    # on each pop
    # If length==nil, pop just 1 level up
    def pop(length = nil, &block)
      if length
        if @stack.last && @stack.last > length
          @stack.pop
          yield if block_given?
          self.pop(length, &block)
        else
          @baseline = @stack.last ? length : 0
        end
      else
        if @stack.last
          @stack.pop
          yield if block_given?
          @baseline = @stack.last || 0
        end
      end
    end

    def flush(&block)
      while @stack.last do
        yield if block_given?
        @stack.pop
      end
      @baseline = 0
    end

    # for debug
    def status
      @stack.inspect
    end
  end

  # parse one file, build Absyn tree, then generate HTML
  def parse(in_file, visitor)
    @yydebug      = true          if ENV['YYDEBUG']
    @indent_stack = NestStack.new
    @header_stack = NestStack.new

    @in_verbatim  = false
    @in_file      = in_file
    File.open(in_file) do |io|
      @in_io = io
      yyparse self, :scan
    end
    visitor.run_file(in_file, @root)
  end

  # return absyn tree
  def tree
    @root
  end

private
  class ScanError < Exception; end

  def scan(&block)
    @src_line = 0
    while line = @in_io.gets do
      debug("@in_verbatim = #{@in_verbatim.inspect}")
      @src_line += 1
      case line
      when /^\s*$/
        if @in_verbatim
          yield [:STRING, "\n"]
        else
          indent_or_dedent(0, &block)
          yield [:WHITELINE, nil]
        end
      when /^(={1,6})\s+(.*)$/
        header_nest($1.length, &block)
        yield [:H,       $1.length]
        yield [:STRING,  $2]
      when /^(\s*)(\d+\.\s+)(.*)$/
        on_list_item(line, '#', $1.length, $2.length, $3, &block)
      when /^(\s*)(\*\s+)(.*)$/
        on_list_item(line, '*', $1.length, $2.length, $3, &block)
      when /^(\s*)(\S.*)::\s*$/
        if !on_item($1.length, $2 + "::\n", &block)
          yield [:DT, $2]
        end
      when /^(\s*)((\S.*)::\s+(.*))$/
        if !on_item($1.length, $2 + "\n", &block)
          yield [:CDT, $3]
          yield [:STRING, $4]
        end
      when /^(\s*)(.*)$/
        length = $1.length
        if indent_or_dedent(length, &block)
          @in_verbatim = true
        end
        yield [:STRING,
               (@in_verbatim ?
                   ' ' * (length - @indent_stack.baseline) :
                   '') + $2 + "\n"]
      else
        raise ScanError
      end
    end
    @indent_stack.flush{ yield [')', nil] }
    @header_stack.flush{ yield ['}', nil] }
    yield [false, nil]
  end

  class NoSrcLine < ParseError; end

  def on_error(et, ev, values)
    print_line('Juli syntax error')
    raise ParseError
  rescue NoSrcLine
    raise ParseError, sprintf("Juli syntax error at line %d\n", @src_line)
  end

  def on_list_item(line, token, length1, length2, str, &block)
    length  = length1 + length2
    debug_indent("list item('#{token}')", length)
    if @in_verbatim
      if @indent_stack.baseline <= length1
        yield [:STRING,  line]
      else
        # after verbatim, dedent just 1-level because there is no
        # deeper nest in verbatim
        dedent(&block)
        @in_verbatim = false
        indent_or_dedent_on_non_verbatim(length, &block)
        yield [token, nil]
        yield [:STRING, str + "\n"]
      end
    else
      base_line_before = @indent_stack.baseline
      indent_or_dedent(length, &block)
      if base_line_before > 0 && @indent_stack.baseline == 0
        warn('Incorrect nest here, but reset it and continue to process.')
        indent(length, &block)
      end
      yield [token, nil]
      yield [:STRING, str + "\n"]
    end
  end

  # action on dictionary list and compact dictionary list
  #
  # 1st, check indent, dedent, or continue.
  # 2nd, if in verbatime, yield string.
  # otherwise, return in_verbatim to tell caller to do the 'NON verbatim'
  # case.
  #
  # === RETURN
  # in verbatim
  def on_item(length, str, &block)
    if indent_or_dedent(length, &block)
      @in_verbatim = true
    end
    if @in_verbatim
      yield [:STRING, str]
    end
    @in_verbatim
  end

  # calculate indent level and yield '(' or ')' correctly
  #
  # === RETURN
  # true::  not @in_verbatim and  @indent_stack.baseline < length
  # false:: other case
  def indent_or_dedent(length, &block)
    if @in_verbatim
      debug_indent('in_verbatim', length)
      if @indent_stack.baseline > length    # end of verbatim
        dedent(length, &block)
        @in_verbatim = false
      end
      false
    else
      indent_or_dedent_on_non_verbatim(length, &block)
    end
  end

  def indent_or_dedent_on_non_verbatim(length, &block)
    debug_indent('NOTverbatim', length)
    if @indent_stack.baseline < length    # begin verbatim
      indent(length, &block)
      true
    elsif @indent_stack.baseline > length
      dedent(length, &block)
      false
    end
  end

  def indent(length, &block)
    @indent_stack.push(length)
    yield ['(', nil]
  end

  def dedent(length=nil, &block)
    @indent_stack.pop(length) do
      yield [')', nil]
    end
  end

  # calculate header level and yield '(' or ')' correctly
  def header_nest(length, &block)
    # at header level change, flush indent_stack
    @indent_stack.flush{ yield [')', nil] }
    @in_verbatim = false

    if @header_stack.baseline < length
      @header_stack.push(length)
      yield ['{', nil]
    elsif @header_stack.baseline > length
      @header_stack.pop(length) do
        yield ['}', nil]
      end
    end
  end

  # print indent info on debug
  def debug_indent(key, length)
    debug(sprintf(
        "indent(%s): @indent_stack(%s,%d), length=%d",
        key,
        @indent_stack.status,
        @indent_stack.baseline,
        length))
  end

  # print str with source text line info to $stderr.
  # If @src_line is not found, NoSrcLine error is raised.
  def print_line(str)
    File.open(@in_file) do |io|
      line = 0
      while line_str = io.gets do
        line += 1
        if @src_line == line
          return $stderr.printf("%s: %s\n%04d: %s\n",
                    @in_file,
                    str,
                    @src_line,
                    line_str)
        end
      end
    end
    raise NoSrcError
  end

  def warn(str)
    print_line('WARN: ' + str)
  end

  # general debug method
  def debug(str)
    @racc_debug_out.print(str, "\n") if @yydebug
  end
...end parser.y/module_eval...
##### State transition tables begin ###

racc_action_table = [
     6,    35,     7,    32,    10,    11,    33,    17,    24,    13,
    15,     6,    22,     7,    44,    10,    11,     3,    17,    16,
    13,    15,     6,    17,     7,    39,    10,    11,    27,    27,
    13,    13,    15,     6,    15,     7,    30,    10,    11,    31,
    41,    11,    13,    15,    11,   nil,    22,    24 ]

racc_action_check = [
     2,    20,     2,    18,     2,     2,    19,    18,    20,     2,
     2,    37,    19,    37,    42,    37,    37,     1,    42,     3,
    37,    37,    38,     5,    38,    25,    38,    38,    25,     7,
     8,    38,    38,    43,     9,    43,    13,    43,    43,    15,
    27,    31,    43,    43,     6,   nil,     6,     6 ]

racc_action_pointer = [
   nil,    17,    -2,    19,   nil,    16,    37,    21,    19,    22,
   nil,   nil,   nil,    29,   nil,    37,   nil,   nil,     0,     3,
    -2,   nil,   nil,   nil,   nil,    20,   nil,    33,   nil,   nil,
   nil,    34,   nil,   nil,   nil,   nil,   nil,     9,    20,   nil,
   nil,   nil,    11,    31,   nil ]

racc_action_default = [
    -2,   -29,    -1,   -29,    -3,    -4,   -29,   -29,    -9,   -10,
   -11,   -12,   -23,   -29,   -26,   -29,    45,   -13,   -29,   -29,
   -29,   -17,    -2,   -20,    -2,   -29,   -14,   -29,   -24,   -27,
   -25,   -29,    -5,    -7,   -18,    -8,   -21,   -19,   -22,    -6,
   -15,    -2,   -29,   -16,   -28 ]

racc_goto_table = [
     2,    18,    26,    23,     1,    21,    25,    19,    20,    28,
    29,   nil,   nil,   nil,   nil,   nil,   nil,    36,    34,   nil,
    40,   nil,    37,   nil,    38,   nil,    42,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,    43 ]

racc_goto_check = [
     2,     4,    10,    12,     1,    11,     5,     6,     7,    13,
    14,   nil,   nil,   nil,   nil,   nil,   nil,    12,    11,   nil,
    10,   nil,     2,   nil,     2,   nil,     4,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,     2 ]

racc_goto_pointer = [
   nil,     4,     0,   nil,    -5,    -1,     1,     2,   nil,   nil,
    -5,    -1,    -3,     1,     1 ]

racc_goto_default = [
   nil,   nil,   nil,     4,     5,   nil,   nil,   nil,     8,     9,
   nil,   nil,   nil,    12,    14 ]

racc_reduce_table = [
  0, 0, :racc_error,
  1, 14, :_reduce_1,
  0, 15, :_reduce_2,
  2, 15, :_reduce_3,
  1, 16, :_reduce_4,
  3, 16, :_reduce_5,
  3, 16, :_reduce_6,
  3, 16, :_reduce_7,
  3, 16, :_reduce_8,
  1, 16, :_reduce_none,
  1, 16, :_reduce_none,
  1, 16, :_reduce_11,
  1, 17, :_reduce_none,
  2, 17, :_reduce_13,
  1, 18, :_reduce_14,
  2, 18, :_reduce_15,
  3, 23, :_reduce_16,
  1, 19, :_reduce_17,
  2, 19, :_reduce_18,
  2, 24, :_reduce_19,
  1, 20, :_reduce_20,
  2, 20, :_reduce_21,
  2, 25, :_reduce_22,
  1, 21, :_reduce_23,
  2, 21, :_reduce_24,
  2, 26, :_reduce_25,
  1, 22, :_reduce_26,
  2, 22, :_reduce_27,
  4, 27, :_reduce_28 ]

racc_reduce_n = 29

racc_shift_n = 45

racc_token_table = {
  false => 0,
  :error => 1,
  "(" => 2,
  ")" => 3,
  "{" => 4,
  "}" => 5,
  :WHITELINE => 6,
  :STRING => 7,
  :H => 8,
  "*" => 9,
  "#" => 10,
  :CDT => 11,
  :DT => 12 }

racc_nt_base = 13

racc_use_result_var = false

Racc_arg = [
  racc_action_table,
  racc_action_check,
  racc_action_default,
  racc_action_pointer,
  racc_goto_table,
  racc_goto_check,
  racc_goto_default,
  racc_goto_pointer,
  racc_nt_base,
  racc_reduce_table,
  racc_token_table,
  racc_shift_n,
  racc_reduce_n,
  racc_use_result_var ]

Racc_token_to_s_table = [
  "$end",
  "error",
  "\"(\"",
  "\")\"",
  "\"{\"",
  "\"}\"",
  "WHITELINE",
  "STRING",
  "H",
  "\"*\"",
  "\"#\"",
  "CDT",
  "DT",
  "$start",
  "text",
  "blocks",
  "block",
  "textblock",
  "chapters",
  "ulist",
  "olist",
  "cdlist",
  "dlist",
  "chapter",
  "ulist_item",
  "olist_item",
  "cdlist_item",
  "dlist_item" ]

Racc_debug_parser = true

##### State transition tables end #####

# reduce 0 omitted

module_eval(<<'.,.,', 'parser.y', 7)
  def _reduce_1(val, _values)
     @root = val[0]
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 10)
  def _reduce_2(val, _values)
     Absyn::ArrayNode.new
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 11)
  def _reduce_3(val, _values)
     val[0].add(val[1]) if val[1]; val[0]
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 14)
  def _reduce_4(val, _values)
     Absyn::StrNode.new(val[0])
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 15)
  def _reduce_5(val, _values)
     Absyn::Verbatim.new(val[1])
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 16)
  def _reduce_6(val, _values)
     val[1]
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 17)
  def _reduce_7(val, _values)
     val[1]
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 18)
  def _reduce_8(val, _values)
     val[1]
  end
.,.,

# reduce 9 omitted

# reduce 10 omitted

module_eval(<<'.,.,', 'parser.y', 21)
  def _reduce_11(val, _values)
     nil
  end
.,.,

# reduce 12 omitted

module_eval(<<'.,.,', 'parser.y', 25)
  def _reduce_13(val, _values)
     val[0] + val[1]
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 37)
  def _reduce_14(val, _values)
     h = Absyn::ArrayNode.new; h.add(val[0])
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 38)
  def _reduce_15(val, _values)
     val[0].add(val[1])
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 40)
  def _reduce_16(val, _values)
     Absyn::Chapter.new(val[0], val[1], val[2])
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 44)
  def _reduce_17(val, _values)
     l = Absyn::UnorderedList.new; l.add(val[0])
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 45)
  def _reduce_18(val, _values)
     val[0].add(val[1])
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 47)
  def _reduce_19(val, _values)
     val[1]
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 51)
  def _reduce_20(val, _values)
     l = Absyn::OrderedList.new; l.add(val[0])
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 52)
  def _reduce_21(val, _values)
     val[0].add(val[1])
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 54)
  def _reduce_22(val, _values)
     val[1]
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 58)
  def _reduce_23(val, _values)
     l = Absyn::CompactDictionaryList.new; l.add(val[0])
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 59)
  def _reduce_24(val, _values)
     val[0].add(val[1])
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 61)
  def _reduce_25(val, _values)
     Absyn::CompactDictionaryListItem.new(val[0],val[1])
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 65)
  def _reduce_26(val, _values)
     l = Absyn::DictionaryList.new; l.add(val[0])
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 66)
  def _reduce_27(val, _values)
     val[0].add(val[1])
  end
.,.,

module_eval(<<'.,.,', 'parser.y', 68)
  def _reduce_28(val, _values)
     Absyn::DictionaryListItem.new(val[0], val[2])
  end
.,.,

def _reduce_none(val, _values)
  val[0]
end

  end   # class Parser
end   # module Juli


